from typing import Generic, TypeVar

from rainbowadn.flow.core import *

__all__ = ('ConstMapper',)

Element = TypeVar('Element')
Mapped = TypeVar('Mapped')


class ConstMapper(Mapper[Element, Mapped], Generic[Element, Mapped]):
    def __init__(self, value: Mapped):
        self.value = value

    async def map(self, element: Element) -> Mapped:
        return self.value
