import time

from .instrumentation import Instrumentation

__all__ = ('Measure',)


class Measure(Instrumentation):
    def __init__(self, target, methodname: str):
        super().__init__(target, methodname)
        self.log: list[float] = []

    async def instrument(self, method, *args, **kwargs):
        start = time.time()
        result = await method(*args, **kwargs)
        self.log.append(time.time() - start)
        return result
